#include "common.h"

/*************************************************************************/
extern void initlocale(const char *package)
{
  setlocale(LC_ALL, "");
  bindtextdomain(package, LOCALEDIR);
  textdomain(package);
}

/*************************************************************************/
extern int strput(char *p, char *a, char *b, int size)
{
  int la = strlen(a);
  int lb = strlen(b);
  if (la + lb > size) return 0;
  memcpy(p, a, la);
  memcpy(p + la, b, lb);
  p[la + lb] = '\0';
  return 1;
}

/*************************************************************************/
extern int strput3(char *p, char *a, char *b, char *c, int size)
{
  int la = strlen(a);
  int lb = strlen(b);
  int lc = strlen(c);
  if (la + lb > size) return 0;
  memcpy(p, a, la);
  memcpy(p + la, b, lb);
  memcpy(p + la + lb, c, lc);
  p[la + lb + lc] = '\0';
  return 1;
}

/*************************************************************************/
extern int streq(const char *a, const char *b)
{
  return strcmp(a, b) == 0;
}

/*************************************************************************/
extern void myread(char *p, FILE *f, size_t size)
{
  size_t s;
  s = fread(p, 1, size, f);
  assert(s == size);
}

/*************************************************************************/
extern int get_int(FILE *f)
{
  int r;

  myread((char *)&r, f, sizeof(int));
  return r;
}

/*************************************************************************/
extern char *get_string(FILE *f, int *size)
{
  int i = get_int(f);
  char *p = malloc(i * sizeof(char));
  myread(p, f, i);
  if (size) *size = i;
  return p;
}

/*************************************************************************/
extern char **get_string_array(FILE *f, int *nb)
{
  int i = get_int(f);
  char **r = malloc(i * sizeof(char *));
  int j, size;
  char *q, *p = get_string(f, &size);
  if (nb) *nb = i;
  for (j = 0, q = p; j < i; j++) {
    r[j] = q;
    q += strlen(q) + 1;
    assert(q <= p + size);
  }
  return r;
}

/*************************************************************************/
extern GtkWidget *PACK_(GtkWidget *parent, GtkWidget *widget,
                        gint vert, gint horiz, gint padding)
{
  gtk_box_pack_start(GTK_BOX(parent), widget, vert, horiz, padding);
  gtk_widget_show(widget);
  return widget;
}

/*************************************************************************/
extern GtkWidget *PACK00_(GtkWidget *parent, GtkWidget *widget, gint padding)
{
  return PACK_(parent, widget, FALSE, FALSE, padding);
}

/*************************************************************************/
extern GtkWidget *PACK10_(GtkWidget *parent, GtkWidget *widget, gint padding)
{
  return PACK_(parent, widget, TRUE,  FALSE, padding);
}

/*************************************************************************/
extern GtkWidget *PACK01_(GtkWidget *parent, GtkWidget *widget, gint padding)
{
  return PACK_(parent, widget, FALSE, TRUE,  padding);
}

/*************************************************************************/
extern GtkWidget *PACK11_(GtkWidget *parent, GtkWidget *widget, gint padding)
{
  return PACK_(parent, widget, TRUE,  TRUE,  padding);
}

/*************************************************************************/
extern GtkWidget *PACK00(GtkWidget *parent, GtkWidget *widget)
{
  return PACK00_(parent, widget, 0);
}

/*************************************************************************/
extern GtkWidget *PACK10(GtkWidget *parent, GtkWidget *widget)
{
  return PACK10_(parent, widget, 0);
}

/*************************************************************************/
extern GtkWidget *PACK01(GtkWidget *parent, GtkWidget *widget)
{
  return PACK01_(parent, widget, 0);
}

/*************************************************************************/
extern GtkWidget *PACK11(GtkWidget *parent, GtkWidget *widget)
{
  return PACK11_(parent, widget, 0);
}

/*************************************************************************/
extern void _gtk_error_(char *msg, char *msg2, char *button_msg)
{
  GtkWidget *window, *hbox, *vbox, *button;

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Error...");

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(window), hbox);

  PACK11_(hbox, vbox = gtk_vbox_new(FALSE, 0), 40);

  PACK01_(vbox, gtk_label_new(msg), 5);
  if (msg2)PACK01(vbox, gtk_label_new(msg2));
    PACK10(PACK11(vbox, gtk_hbox_new(FALSE, 0)),
  button = gtk_button_new_with_label(button_msg));
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

  gtk_widget_grab_focus(button);
  gtk_grab_add(window);
  gtk_widget_show_all(window);
  gtk_main();

  gtk_widget_destroy(window);
}

