#include "common.h"

int chosen;

/*************************************************************************/
static void button_ok_clicked(GtkCList *clist)
{
  if (clist->selection)
    chosen = (int) clist->selection->data + 1;
  gtk_main_quit();
}

/*************************************************************************/
void list_clicked(GtkCList *clist, GdkEventButton *event)
{
  if (event->type == GDK_2BUTTON_PRESS &&
      gtk_clist_get_selection_info(GTK_CLIST(clist), event->x, event->y,
                                   NULL, NULL))
  button_ok_clicked(clist);
}

/*************************************************************************/
int chooser(const char *msg, char **list)
{
  GtkWidget *window;
  GtkWidget *vbox, *hbox, *scrolled_window;
  GtkCList *clist;
  GtkWidget *button_ok, *button_cancel;

  chosen = 0;
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize(GTK_WIDGET(window), 500, 350);

  gtk_window_set_title(GTK_WINDOW(window), "gchooser");
  gtk_signal_connect(GTK_OBJECT(window), "destroy",
                     (GtkSignalFunc)gtk_main_quit, NULL);
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
                     (GtkSignalFunc)gtk_main_quit, NULL);
    
  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(vbox);

  PACK01(vbox, gtk_label_new(msg));

  PACK11(vbox, scrolled_window = gtk_scrolled_window_new (NULL, NULL));
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
                                 GTK_POLICY_NEVER,
                                 GTK_POLICY_AUTOMATIC);

  clist = (GtkCList *) gtk_clist_new(1);

  gtk_container_add(GTK_CONTAINER(scrolled_window), GTK_WIDGET(clist));
  gtk_widget_show(GTK_WIDGET(clist));
  gtk_clist_set_selection_mode(clist, GTK_SELECTION_BROWSE);
  gtk_signal_connect(GTK_OBJECT(clist), "button_press_event",
                     GTK_SIGNAL_FUNC(list_clicked), NULL);

  for (; *list; list++)
    gtk_clist_append(clist, list);
  gtk_clist_select_row(clist, chosen, 0);

  PACK01(vbox, hbox = gtk_hbox_new(FALSE, 0));

  PACK11(hbox, button_ok = gtk_button_new_with_label(_("Ok")));
  PACK11(hbox, button_cancel = gtk_button_new_with_label(_("Cancel")));
  gtk_signal_connect_object(GTK_OBJECT(button_ok), "clicked",
                             GTK_SIGNAL_FUNC(button_ok_clicked),
                             GTK_OBJECT(clist));
  gtk_signal_connect(GTK_OBJECT(button_cancel), "clicked",
                     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

  gtk_widget_show(window);
  gtk_main();

  return chosen;
}

/*************************************************************************/
int main(int argc, char **argv) {

  initlocale("gchooser");

  if (argc == 1)
  {
    fprintf(stderr, _("usage: gchooser message <list>\n"));
    exit(1);
  }

  gtk_init(NULL, NULL);
  exit(chooser(argv[1], argv + 2));
}

